"use strict";

document.addEventListener('click', evt => {
	let $match = evt.target.closest('.track-click'),
		$a = evt.target.closest('a'),
		eventCategory = null,
		eventAction = null,
		eventLabel = null;

	if($a === null) {
		// Only track a click if it was on a link.
		return;
	}

	if($match !== null) {
		if(!!evt.target.dataset.trackCategory) {
			eventCategory = evt.target.dataset.trackCategory;
		}
		else if(!!$a.dataset.trackCategory) {
			eventCategory = $a.dataset.trackCategory;
		}
		else if(!!$match.dataset.trackCategory) {
			eventCategory = $match.dataset.trackCategory;
		}

		if(!!evt.target.dataset.trackAction) {
			eventAction = evt.target.dataset.trackAction;
		}
		else if(!!$a.dataset.trackAction) {
			eventAction = $a.dataset.trackAction;
		}
		else if(!!$match.dataset.trackAction) {
			eventAction = $match.dataset.trackAction;
		}
		else {
			eventAction = 'click';
		}

		eventLabel = $a.innerText;

		ga('send', 'event', {
			eventCategory, eventAction, eventLabel
		});
	}
});